package com.jspmaster.text;

import java.io.UnsupportedEncodingException;


public class StringProcess {
  	public static String ascToksc(String str){
  		try {
	    		if(str==null) return null;
	    		return new String(str.getBytes("8859_1"),"euc-kr");
	    	}catch ( UnsupportedEncodingException e){
	    		return str;
	    	}
  	}
  	
  	public static String kscToasc(String str){
  		try {
  			if (str==null) return null;
  			return new String(str.getBytes("euc-kr"),"8859_1");
  		}catch (UnsupportedEncodingException e){
  			return str;
  		}
  	}
	//̰ get  searchword óϴ ̴.
   	public static String kwordProcess(String str){
  		try {
			if(str==null) return null;
			return new String(str.getBytes("8859_1"),"euc-kr");
	    	}catch ( UnsupportedEncodingException e){
	    		return str;
	    	}
  	}
  	 	
  	// Ư ڿ ġȯ
	public static String repWord(String buffer, String OldWord, String NewWord) {
   		int sp=0;
   		int ep=0;

   		while (ep <= buffer.length()) {
       			ep = buffer.indexOf(OldWord, sp);
       			sp=ep+NewWord.length();
       			if (ep == -1) break;
       			buffer = buffer.substring(0, ep) + NewWord + buffer.substring(ep+OldWord.length());
   		}
   		return buffer;
	}

  	// urlּҿٰ ũɱ
	public static String repUrl(String buffer) {

		int sp=0;
		int ep=0;
		int cp=0;

		while (ep <= buffer.length()) {
			ep = buffer.indexOf("http://", sp);
			if (ep == -1) break;
			
			int b = buffer.indexOf("&nbsp;", ep);
			int n = buffer.indexOf("<br>", ep);

			// cp ٲ url ϴ ̴. 4 Ǽ
			if(b != -1){
				if(n != -1) cp = b>n? n : b;
				else cp = b;
			}else{
				if(n != -1) cp = n;
				else cp = buffer.length();
			}
			String oldUrl = buffer.substring(ep, cp);
			String newUrl = "<a href='"+oldUrl+"' target='_blank'>"+oldUrl+"</a>";
			sp = ep+newUrl.length();
			buffer = buffer.substring(0, ep) + newUrl + buffer.substring(cp);
		}
		return buffer;
	}
	
	// ȭ 
	public static String getMoneyFormat(String s){
		String temp = "";
		boolean chk = true;

		while (chk){
			if (s.length() >= 4){
				if (temp.length() >0)
					temp = "," + temp;
				temp = s.substring(s.length()-3) + temp;
				s = s.substring(0, s.length()-3);
			}else {
				if (temp.length()>0)
					temp = s + "," + temp;
				else
					temp = "0";
				chk = false;
			}
		}
		
		return temp;
	}
	
	public static String getMoneyFormat(int s){
		String str = s + "";
		return getMoneyFormat(str);
	}
}